



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Libevent源码学习笔记一：event2/event.h</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Libevent源码学习笔记一：event2/event.h</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-13 11:37:43 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>一、libevent标准使用方法：</h2>
<p>　　每个程序使用Libevent必须include &lt;event2/event.h&gt; 头文件，并 传给 -levent &nbsp;链接器。如果只是想使用主要的event和buffered IO-based code，不想链接任何协议代买，使用链接 -levent_core。</p>
<h2>二、安装库设置</h2>
<p>　　在调用Libevent其他函数时，需要设置库。例如在应用中使用多线程，需要先初始化线程支持，使用evthread_use_pthreads() or evthread_use_windows_threads().在&lt;event2/thread.h&gt;获取更多信息。</p>
<p>　　另外，可以使用event_set_mem_functions来替换Libevent 内存管理，想要测试 debug，使用event_enable_debug_mode().</p>
<h2>三、 创建event base</h2>
<p>　　Libevent是反应器(Reactor)模式，event_base就相当于反应器，event_base 负责监视event是等待状态还是就绪状态，每个event与一个event_base关联。</p>
<h2>四、事件通知机制</h2>
<p>　　一个文件描述符对应一个event结构体，可以使用event_new()来创建一个event结构体，或者是声明一个event structure，然后使用event_assign()来初始化event的成员。为了实现通知，使用event_add()来将事件添加到列表。只要事件是活动的，事件结构必须保持分配，因此它一般应该在堆上分配。</p>
<h2>五、循环处理事件</h2>
<p>　　最后调用event_base_dispatch() 来循环处理事件。也可以使用event_base_loop 来实现更细致的控制。</p>
<p>　　一个线程只能处理一个event_base。If you want to run events in multiple threads at once, you can&nbsp;either have a single event_base whose events add work to a work queue,or you can create multiple event_base objects.</p>
<h2>六、bufferevent I/O Buffers 缓冲输入输出</h2>
<p>　　Libevent提供 一个 buffered I/O abstraction 在常规事件回调的顶部。这个abstraction 是 bufferevent。一个 bufferevent 提供自动填充和清理输入和输出缓冲。使用buffered event不再直接处理I/O,而是从输入缓冲读，输出缓冲区写。</p>
<p>　　一旦通过bufferevent_socket_new()初始化，bufferevnet 结构体 通过bufferevent_enable()和bufferevent_diable()实现重复使用。以前是直接读写socket，使用bufferevent_socket后，改为使用bufferevent_read()和bufferevent_write()。</p>
<p>读缓存水位分析：</p>
<p>1、&nbsp; bufferevent用于数据接收和发送缓存。</p>
<p>2、&nbsp; bufferevent内建了两个struct bufferevent对象，分别用于发送和接收缓存。</p>
<p>3、&nbsp; 水位值用于实现对缓存区的管理。</p>
<p>4、&nbsp; 从网络模型分析bufferevent会自动从socket读取数据缓存在bufferevent的接收缓存中。</p>
<p>5、&nbsp; 当bufferevent存储的数据到达低水位值时读回调函数触发。</p>
<p>6、&nbsp; 低水位是0时，只要bufferevent从网络收数据就会触发读回调，也即数据可以立即被用户读走。</p>
<p>7、&nbsp; 读回调函数常规操作是从bufferevent中读取数据（用户读取数据）。</p>
<p>8、&nbsp; 但是当bufferevent读取的速度大于用户从bufferevent读取速度是，bufferevent中的数据量会达到高水位值。</p>
<p>9、&nbsp; 当bufferevent缓存数据量达到高水位值时，bufferevent会停止从网络接收数据。</p>
<p>10、当用户从bufferevent中读取了数据使水位值低于高水位值时，bufferevent又可以从网络中接收新的数据。</p>
<p>写缓存水位分析：</p>
<p>1、&nbsp; 用户先将数据写入到bufferevent发送缓存。</p>
<p>2、&nbsp; 当bufferevent发送缓存存储的数据量达到低水位时，回调函数将被触发。</p>
<p>3、&nbsp; 当低水位为0时，bufferevent缓存为空，写进数据时写回调被触发。</p>
<p>4、&nbsp; 回调函数的常规操作是将bufferevent发送缓存数据写到网络中。</p>
<p>5、&nbsp; 当用户写入发送缓存数据快于回调函数将数据写到网络中时，水位值将达到高水位值。</p>
<p>6、&nbsp; 高水位值没有使用。</p>
<h2>七、定时器</h2>
<p>　　Libevent可以创建定时器来当超时时来调用回调函数。evtimer_new() 宏 返回一个使用定时器的event。为了激活定时器，调用evtimer_add()宏。可以使用evtimer_del()使用定时器失活。</p>
<p>这些宏使用对event_new(),event_add(),event_del的包装。</p>
<h2>八、evdns Asynchronous DNS resolution 异步DNS解决方案</h2>
<p>Libevent 提供一个异步DNS来替代标准的DNS解决器。在&lt;event2/dns.h&gt;有更多函数</p>
<h2>九、evhttp event-driven HTTP servers</h2>
<p>Libevent提供一个非常简单事件驱动的HTTP服务器，可以集成到程序中并处理HTTP请求</p>
<p>&lt;event2/http.h&gt;</p>
<h2>十、evrpc &nbsp;A framework for RPC servers and clients</h2>
<div>
<div>Libevent provides a framework for creating RPC servers and clients. It&nbsp;takes care of marshaling and unmarshaling all data structures.</div>
</div>
<div>
<div>event2/event.h</div>
<div>The primary libevent header</div>
<h2>十一、Libevent主要头文件</h2>
<div>1.event2/thread.h</div>
<div>Functions for use by multithreaded programs</div>

<div>2.event2/buffer.h and event2/bufferevent.h</div>
<div>  Buffer management for network reading and writing</div>

<div>3.event2/util.h</div>
<div>  Utility functions for portable nonblocking network code</div>

<div>4.event2/dns.h</div>
<div>  Asynchronous DNS resolution</div>

<div>5.event2/http.h</div>
<div>  An embedded libevent-based HTTP server</div>

<div>6.event2/rpc.h</div>
<div>  A framework for creating RPC servers and clients</div>
</div>
<h2>十二、event structure</h2>
<p>事件处理步骤：</p>
<p>　　1.event_new()创建event</p>
<p>　　2.event_add()将event添加到event_base中</p>
<p>　　3.不再使用事件时，event_free()删除事件</p>
<p>事件分为persistent和non-persistent。non-persistent事件，被触发后只执行一次，然后状态变为non-pending；persistent事件当被触发执行回调函数后，状态为pending然后在event_base继续等待执行，只用使用event_del()手动删除事件将状态改为non-pending。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8o16o5q.html">Windows Phone 的 TextBox 的实现 PropertyChanged</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ol63l8.html">win server 2008 r2 sharepoint 域环境安装经历</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2empxq.html">Angular JS &lbrack;Draft&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw27kkq.html">asynchronous-logging-with-log4j-2--转</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zmd269.html">MySQL与SQL比较有那些区别呢</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xwd3g9.html">bzoj3035&colon; 导弹防御塔</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vdnnn8.html">Sublime Text2 多行编辑快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdem738.html">方便的Chrome取色插件ColorPick Eyedropper &lbrack;设计&comma; FE必备&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1oyrj8.html">ios开发中各种版本、设备的区分</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkn6108.html">【源代码】基于Android和蓝牙的单片机温度採集系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yygkn8.html">HDU 1864最大报销额&lpar;一维背包）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y06eg8.html">spring-data-mongodb中的MongoTemplate与MongoRepository</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o1gkg8.html">Navicat工具、pymysql模块   sql注入</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy5d6n9.html">Percona Xtradb Cluster的设计与实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/93po7rn8.html">【css】gradient匹配ps渐变叠加效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnndw1kq.html">Matlab PCA 算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pg0yr8.html">PBS命令和使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql14p209.html">Bootstrap3&period;0和bootstrap2&period;x的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve422y9.html">20155224 2016-2017-2 《Java程序设计》第3周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mj3x068.html">xv6&sol;sh&period;c</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlolwmxq.html">（微信小程序）二 ： 创建一个页面。</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kmjkj79.html">SQL 除去回车符 除去空格符</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e04rwjq.html">MDI-设置子窗体只能弹出一个--单例模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kmjdzj9.html">java温故而知新（9）OOP（面向对象编程）理念</a>
			</li>
						<li><a href="https://www.batexi.com/a/93jwklw8.html">C中的私有成员</a>
			</li>
						<li><a href="https://www.batexi.com/a/q15rnzz9.html">express的proxy实现前后端分离</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlol2lxq.html">关于iframe中使用fixed定位的一些问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlol2y1q.html">Bzoj1835：&lbrack;ZJOI2010&rsqb;基站选址</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2x5edx9.html">洛谷P1155 双栈排序&lpar;贪心&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q15roo29.html">css的字体样式怎么写</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
